package com.bocloud.cmp.model;

import lombok.Data;

import java.util.Date;
import java.util.List;

/**
 * OpenStack浮动IP业务类
 *
 * @author wangyu
 * @version 1.0
 * @since 2017年8月28日
 */
@Data
public class FloatingIpModel {
    private String floatingIpUuid;
    private String routerUuid;
    private String tenantUuid;
    private String floatingNetworkUuid;
    private String floatingNetworkName; // pool名称
    private String floatingIpAddress;
    private String fixedIpAddress;
    private String portUuid;
    private String status;
    private List<PortModel> ports;
    private String instanceId;
    private String networkCardUuid;
    private String privateIpAddress; // 当floatip绑定网卡时 需要指定ip
    private String qosPolicyId;
    private String resourceGroupUuid;
    private Date gmtCreate;
    private String name;
    private String regionId;
    private Integer addressCount;
    private String bandwidth; // EIP的带宽峰值，单位为Mbps
    private String ipChargeType;
    private Date expiredTime;
    private Date createTime;
    private String instanceType;
    private String internetChargeType;
    private Integer needIcp;
    private String serviceName; // 华为SDN浮动ip云平台名称
    private Integer bandwidthSize;
    private String bandwidthName;
    private String bandwidthId;
    private String publicType;
    private String resourceLabel; //标签
}
