package com.bocloud.cmp.model;

import lombok.Data;

import java.util.List;

/**
 * @ClassName: ServerLimitsModel
 * @Description: 华为云租户配额信息 （必选--》是/否）
 * @Author lxy
 * @Date 2021/8/2 10:14
 */
@Data
public class ServerLimitsModel {
    /**
     * 镜像元数据最大的长度（是）
     */
    private Integer maxImageMeta;

    /**
     * 可注入文件的最大个数（是）
     */
    private Integer maxPersonality;

    /*注入文件内容的最大长度(单位:Byte)。（是）*/
    private Integer maxPersonalitySize;

    /*安全组中安全组规则最大的配置个数。（是）具体配额限制请以VPC配额限制为准。*/
    private Integer maxSecurityGroupRules;

    /**
     * 安全组最大使用个数。（是）
     * 具体配额限制请以VPC配额限制为准。
     */
    private Integer maxSecurityGroups;

    /*服务器组中的最大云主机数。（是）*/
    private Integer maxServerGroupMembers;

    /*服务器组的最大个数。（是）*/
    private Integer maxServerGroups;

    /*可输入元数据的最大长度。（是）*/
    private Integer maxServerMeta;

    /*CPU核数最大申请数量。（是）*/
    private Integer maxTotalCores;

    /*最大的浮动IP使用个数。（是）*/
    private Integer maxTotalFloatingIps;

    /*云服务器最大申请数量。（是）*/
    private Integer maxTotalInstances;

    /*可以申请的SSH密钥对最大数量。（是）*/
    private Integer maxTotalKeypairs;

    /*内存最大申请容量(单位:MB)。（是）*/
    private Integer maxTotalRAMSize;

    /*当前已使用CPU核数。（是）*/
    private Integer totalCoresUsed;

    /*当前浮动IP使用个数。（是）*/
    private Integer totalFloatingIpsUsed;

    /*当前云服务器使用个数。（是）*/
    private Integer totalInstancesUsed;

    /*当前内存使用容量(单位:MB)。（是）*/
    private Integer totalRAMUsed;

    /*当前安全组使用个数。（是）*/
    private Integer totalSecurityGroupsUsed;

    /*已使用的服务器组个数。（是）*/
    private Integer totalServerGroupsUsed;

    /*竞价实例的最大申请数量。（否）*/
    private Integer maxTotalSpotInstances;

    /*竞价实例的CPU核数最大申请数量。（否）*/
    private Integer maxTotalSpotCores;

    /*竞价实例的内存最大申请容量(单位:MB)。（否）*/
    private Integer maxTotalSpotRAMSize;

    /*当前竞价实例的使用个数。（否）*/
    private Integer totalSpotInstancesUsed;

    /*当前竞价实例已使用的CPU核数。（否）*/
    private Integer totalSpotCoresUsed;

    /*当前竞价实例的内存使用容量(单位:MB)。（否）*/
    private Integer totalSpotRAMUsed;

    /*使用该flavor可以申请的弹性云服务器数量。（否）
    值为“-1”时,表示无数量限制。*/
//    private List<ProjectFlavorLimit> limitByFlavor;
}
