package com.bocloud.cmp.model;

import lombok.Data;

import java.util.List;

@Data
public class VDCModel {
    private String uuid;
    private String name;
    private Long cpuTotal;
    private Double memTotal;
    private Double diskTotal;
    private Long cpuUsed;
    private Double memUsed;
    private Double diskUsed;
    private String vdcVal;
    private List<ClusterModel> clusters;
    private List<HostModel> hosts;
    private List<DataStoreModel> stores;
    private List<NetworkModel> networks;
    private List<SwitchModel> switchers;
    private List<ResourcePoolModel> pools;
    private List<VAppModel> vapps;

    //fc新增字段
    private String uri;  // 站点uri
    private String ip;//站点IP
    private Boolean isDc;//是否是域控制器（KVM未支持）
    private Boolean isSelf;//是否是当前站点
    private String status;//vrm状态，(joining:加入域中、exiting:退出域中、normal:正常、fault:故障)
    private String mgntNetworkType;//管理面ip版本，取值ipv4,ipv6
    //fc新增字段

    /**
     *
     */
    public VDCModel() {
        super();
    }

    /**
     * @param name
     * @param cpuTotal
     * @param memTotal
     * @param diskTotal
     * @param cpuUsed
     * @param memUsed
     * @param diskUsed
     * @param clusters
     * @param hosts
     */
    public VDCModel(String name, Long cpuTotal, Double memTotal, Double diskTotal, Long cpuUsed, Double memUsed,
                    Double diskUsed, List<ClusterModel> clusters, List<HostModel> hosts, List<DataStoreModel> stores,
                    String vdcVal) {
        this.name = name;
        this.cpuTotal = cpuTotal;
        this.memTotal = memTotal;
        this.diskTotal = diskTotal;
        this.cpuUsed = cpuUsed;
        this.memUsed = memUsed;
        this.diskUsed = diskUsed;
        this.clusters = clusters;
        this.hosts = hosts;
        this.stores = stores;
        this.vdcVal = vdcVal;
    }
}
