package com.bocloud.cmp.model.fusionsphere;

import com.bocloud.cmp.model.HostModel;
import lombok.Data;

import java.util.List;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: StorageDeviceModel
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2021/10/20 15:43
 */
@Data
public class StorageDeviceModel {
    private String urn;//唯一标识存储设备的urn。
    private String uri;//唯一标识存储设备的uri。
    private String sdUrn;//关联的存储资源URN。
    private String sdId;//存储资源的ID
    private String sdName;//关联的存储资源名称。
    private String name;//用户可读的存储设备名称。
    private String type;//存储设备类型，存储设备类型
    private Integer capacityGb;//容量，以GB为单位。
    private String status;//存储设备状态:NORMAL, ABNORMAL。
    private String refreshTime;//上次扫描时间，UTC时间，格式如：“2012-08-27 20:29:19”。
    private Boolean isThin;//是否支持 精简。
    private String wwn;//SAN设备的LUN对应的wwn号
    private Integer suHostId;//LUN所属的HOST的ID
    private String sanSn;//IPSAN阵列的SN
    private String suLunId;//存储设备对应的LUN在物理存储资源上的ID
    private Integer supportAdl;//存储设备是否支持硬件辅助锁。0表示未知或不涉及，1表示不支持，2表示支持
    private Integer hostNum;//关联主机总数
    private List<HostModel> hostModels;

    private String vdcUri;

}