package com.bocloud.cmp.model.fusionsphere;

import lombok.Data;

import java.util.Map;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: TaskModel
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2021/10/18 15:07
 */
@Data
public class TaskModel {

    private String urn; //任务产生时系统内部生成的标识
    private String uri;  // 可通过此uri访问任务
    private String type;//任务类型，参照接口定义后面任务列表
    private String entityUrn;//对象标识
    private String entityName;//对象名称
    private String startTime;//任务开始时间(long型UTC字符串)
    private String finishTime;//结束时间(long型UTC字符串)
    private String user;//用户名，内部自动触发的任务无用户
    private String status;//任务状态
    private Integer progress;//任务进度百分比，0~100
    private String reason;//附加信息原因值
    private String reasonDes;//附加信息原因描述
    private Boolean cancelable;//任务当前是否可以取消 true 可以取消
    private Boolean cancelled;//任务是否收到取消命令true 收到取消命令
    private Map<String, String> params;//预留，暂未使用。

    private Boolean businessStatus;//对上面status做boolean转换 用与业务判断 云主机/磁盘等等


    public TaskModel() {
    }

    public TaskModel(Boolean businessStatus,String reasonDes) {
        this.reasonDes = reasonDes;
        this.businessStatus = businessStatus;
    }
}