package com.bocloud.cmp.model.sangfor;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.annotation.JSONField;
import lombok.Data;

/**
 * 镜像
 *
 * @author sxp
 * @since 2023/5/31
 */
@Data
public class SangforImage {
    @JSONField(name = "id")
    private String imageUuid;

    private String name;

    private String description;

    @JSONField(name = "image_type")
    private String imageType;// public:公共镜像

    private String status;// active:可用

    @JSONField(name = "os_type")
    private String osType;// 镜像操作系统类型

    @JSONField(name = "disk_format")
    private String diskFormat;// ISO:ISO镜像,aCloud:内置镜像（HCI镜像类型）

    @JSONField(name = "size_mb")
    private Double sizeMb;

    /**
     * 镜像功能种类，普通镜像为normal，服务镜像为service
     */
    private String category;

    /**
     * 镜像所绑定的资源池信息
     * <pre>
     * id string 资源池 ID 是
     * is_available string 镜像在该资源池是否可用：0表示不可用，1表示可用 是
     * arch_type string 资源池架构类型，参见：资源池架构类型 是
     * </pre>
     */
    private JSONArray azs;

    /**
     * 镜像系统内置磁盘信息
     * <pre>
     * id string 磁盘 ID 是
     * storage_id string 存储 ID 是
     * size_mb float 镜像大小（MB） 是
     * preallocate string 磁盘分配方式，参见：磁盘分配方式 是
     * </pre>
     */
    private JSONArray disks;
}
