package com.bocloud.cmp.vm.model;

import lombok.Data;

import java.io.Serializable;

/**
 * 云主机快照创建参数
 *
 * @author wangyu
 * @version 5.0.0-SNAPSHOT
 * @since 2021/3/26
 */
@Data
public class VmSnapshotParam implements Serializable {

    private static final long serialVersionUID = 1022042087876286064L;
    //云主机ID
    private Long serverId;
    //快照名称
    private String name;
    //快照描述
    private String remark;
    //定时快照cron表达式
    private String cron;
    //操作
    private String operate;


    //FusionSphere新增
    //快照类型
    private String snapshotType;
    private Boolean needMemoryShot;//是否制作内存快照
    private Boolean isConsistent;//是否一致性快照

    public VmSnapshotParam() {
    }

    public VmSnapshotParam(Long serverId, String name, String remark, String cron, String operate) {
        this.serverId = serverId;
        this.name = name;
        this.remark = remark;
        this.cron = cron;
        this.operate = operate;
    }

    public VmSnapshotParam(Long serverId, String name, String remark, String cron, String operate, String snapshotType) {
        this.serverId = serverId;
        this.name = name;
        this.remark = remark;
        this.cron = cron;
        this.operate = operate;
        this.snapshotType = snapshotType;
    }
}
